<?php

/**
 * liquidacion_cierre actions.
 *
 * @package    canon
 * @subpackage liquidacion_cierre
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class liquidacion_cierreActions extends sfQuery {

    public $conn;

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {


        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //Session de fecha
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"    
EOD;

        CN_TABLE::executeSQL($sql);

        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();
        /*
         * Manejo de errores
         */
        try {




            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */
            $id_liq_canon = '';
            if (isset($request['id_liq_canon'])) {
                $id_liq_canon = "'" . $request['id_liq_canon'] . "' ";
            }
            $vigencia = '';
            if (isset($request['vigencia'])) {
                $vigencia = "'" . $request['vigencia'] . "' ";
            }

            if ($id_liq_canon == '' || $vigencia == '') {
                throw new Exception("Los parametros obligatorios no fueron enviados");
                exit();
            }

            $fecha_actual = CN_TABLE::fechaSistema();
            $vigencia_actual = date('Y');

            //Crea todos los recibos de una planilla
            $sql = <<<EOD
insert into ca_recibo 

(id_recibo, vigencia, id_det_liq_canon, 
vig_liq, num_recibo, fecha_exped_rec, 
fecha_vence_rec, fecha_pago_oportuno, fecha_anula, 
pago, id_usuario_anula, anulado, 
historico, id_debito)

( 

select 

NVL(( select seq from ca_table_vig_seq where id_vigencia = $vigencia AND nom_entidad = 'CA_RECIBO'  ),0) + ROWNUM as id_recibo, 
$vigencia_actual, tab1.id_det_liq_canon, 
tab1.vigencia, 
NVL((select num_recibo_actual from ca_con_recibo where vigencia = $vigencia ),0)+rownum as num_recibo, 
to_date('$fecha_actual', 'yyyy-mm-dd'), 
to_date(tab2.fecha_inicio, 'yyyy-mm-dd'), to_date(tab2.fecha_inicio, 'yyyy-mm-dd'), null, 
0, null, 0, 0, null

from ca_det_liq_canon tab1 

join ca_anual_etapa tab2 
on tab1.id_anual_etapa=tab2.id_anual_etapa 

where tab1.id_liq_canon=$id_liq_canon 
and tab1.vigencia=$vigencia 
and tab1.anulado=0 
and tab1.aprobado=1

)     
EOD;

            //CN_TABLE::executeSQL($sql);
            $this->conn->execute($sql);


            $sql = <<<EOD
select 

count(*) as count

from ca_det_liq_canon tab1 

join ca_anual_etapa tab2 
on tab1.id_anual_etapa=tab2.id_anual_etapa 

where tab1.id_liq_canon=$id_liq_canon 
and tab1.vigencia=$vigencia 
and tab1.anulado=0 
and tab1.aprobado=1

EOD;

            //CN_TABLE::executeSQL($sql);
            $numRecs = CN_TABLE::executeSQL($sql, true);
            $numRecs = $numRecs[0]['count'];


            /*
             * Obtiene los recibos creados
             * Vista ca_anual_etapa_deb_v para debitos a mas de una anual_etapa - 20170710
             * Se coloca producto debito para solicitud_en_proceso, se coloca observacion de estado - 20170912
             */
//SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
            $sql = <<<EOD
select 
* 
from (

        select 
        tab1.*, 
        tab0.valor, tab0.id_titulo, tab2.fecha_inicio, 
        tab2.fecha_fin, tab2.anualidad, tab3.abreviacion, 
        tab4.cod_titulo, nvl(mg.es_gobernacion,0) as es_gobernacion, 
        aed.id_debito as id_debito_old,
        --PARAMETRIZACION CONCEPTOS CONTABLES
        CASE 
            --Titulos mineros de las gobernaciones delegadas
            when estrev.solicitud_en_proceso = 1 then 'id_producto_ND80' 
            
            when nvl(mg.es_gobernacion,0) = 1 then 
                --CASOS TITULOS GOBERNACIONES
                CASE 
                --ND 68 VIGENCIA ACTUAL
                when extract(year from SYSDATE)=extract(year from tab2.fecha_inicio) then 'id_producto_ND68'
                --ND 69 fechaIniAnu < '25-09-2012'
                when tab2.fecha_inicio<to_date('2012-09-25','YYYY-MM-DD') then 'id_producto_ND69'
                --ND 70 fechaIniAnu >= '25-09-2012'
                else 'id_producto_ND70'
                END
            --Titulos mineros de la ANM
            else 
                --CASOS TITULOS DE LA ANM
                CASE 
                --ND 51 VIGENCIA ACTUAL
                when extract(year from SYSDATE)=extract(year from tab2.fecha_inicio) then 'id_producto_ND51'
                --ND 49 fechaIniAnu < '03-06-2012'
                when tab2.fecha_inicio<to_date('2012-06-03','YYYY-MM-DD') then 'id_producto_ND49'
                --ND 50 fechaIniAnu >= '03-06-2012'
                else 'id_producto_ND50'
                END  
        
        END as id_producto_param,
        
        tab2.id_anual_etapa,
        novtit.id_estado_rev,
        estrev.solicitud_en_proceso,
        case when novtit.id_estado_rev is not null then ',  ESTADO ' || estrev.descripcion || ': ' || novtit.observaciones || '.' else ' ' end as text_estrev
        
        from ca_det_liq_canon tab0 
        
        join ca_recibo tab1 on tab0.id_det_liq_canon=tab1.id_det_liq_canon and tab0.vigencia=tab1.vig_liq
        join ca_anual_etapa tab2 on tab0.id_anual_etapa=tab2.id_anual_etapa
        join ca_etapa tab3 on tab0.id_etapa=tab3.id_etapa
        join rmn_titulo tab4 on tab0.id_titulo=tab4.id_titulo
        
        left join CA_TITULO_MARCA_GOB mg on tab0.id_titulo=mg.id_titulo
        left join ca_anual_etapa_deb_v aed on tab2.ID_ANUAL_ETAPA=aed.id_anual_etapa
        
        left join ca_novedad_rev_tit novtit
        on novtit.id_titulo = tab0.id_titulo and novtit.id_anual_etapa=tab0.id_anual_etapa
        
        left join ca_estado_rev estrev
        on novtit.id_estado_rev = estrev.id_estado_rev
        
        where 
        tab0.id_liq_canon = $id_liq_canon 
        and tab0.vigencia = $vigencia 
        and tab0.anulado = 0 
        and tab0.aprobado = 1

)table1

join 
(

        select 
        
        titper.ID_PERSONA,
        titper.NOMBRE,
        titper.PRIMER_APELLIDO,
        titper.SEGUNDO_APELLIDO,
        titper.TELEFONO,
        titper.CELULAR,
        titper.CORREO,
        titper.CORREO_ALT,
        titper.RAZ_SOC,
        titper.NUM_DOC,
        titper.id_titulo as id_titulo_1,
        titper.id_titulo_persona,
        titper.id_titular
        
        
        from rmn_titulo_persona_mv titper
        
        join (
                SELECT 
                titper.*,
                ROW_NUMBER() OVER (
                PARTITION BY titper.id_titulo
                ORDER BY titper.id_titulo_persona ASC
                ) AS rn
                from rmn_titulo_persona_mv titper
                --mod by harold 22/06/2015 unico rol valido es titular id_rol=26 HARD CODED
                where titper.actual = 1 and titper.id_rol_titulo=26
        )tab
        on titper.id_titulo_persona = tab.id_titulo_persona
        and titper.id_titular = tab.id_titular
        and tab.rn = 1
        
        order by
        titper.id_titulo_persona 

)table2
on table1.id_titulo=table2.id_titulo_1   

order by 
table1.num_recibo  
EOD;

// ) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart           
            //ejecuta y obtiene el resultado del sql
            $records = CN_TABLE::executeSQL($sql, true);

            $cant = count($records);
            $this->logMessage($numRecs . "--- Valores de titulares ---" . $cant);

            if ($numRecs != $cant) {

                $sql = <<<EOD
select 
to_char(wm_concat(cod_titulo)) as cod_titulo 
from 

(
select tab1.*, tab0.valor, tab0.id_titulo, tab2.fecha_inicio, tab2.fecha_fin, tab2.anualidad, tab3.abreviacion, 
    tab4.cod_titulo, nvl(mg.es_gobernacion,0) as es_gobernacion, aed.id_debito as id_debito_old,
    --PARAMETRIZACION CONCEPTOS CONTABLES
      CASE 
        --Titulos mineros de las gobernaciones delegadas
        when nvl(mg.es_gobernacion,0) = 1 then 
          --CASOS TITULOS GOBERNACIONES
          CASE 
            --ND 68 VIGENCIA ACTUAL
            when extract(year from SYSDATE)=extract(year from tab2.fecha_inicio) then 'id_producto_ND68'
            --ND 69 fechaIniAnu < '25-09-2012'
            when tab2.fecha_inicio<to_date('2012-09-25','YYYY-MM-DD') then 'id_producto_ND69'
            --ND 70 fechaIniAnu >= '25-09-2012'
            else 'id_producto_ND70'
          END
        --Titulos mineros de la ANM
        else 
          --CASOS TITULOS DE LA ANM
          CASE 
            --ND 51 VIGENCIA ACTUAL
            when extract(year from SYSDATE)=extract(year from tab2.fecha_inicio) then 'id_producto_ND51'
            --ND 49 fechaIniAnu < '03-06-2012'
            when tab2.fecha_inicio<to_date('2012-06-03','YYYY-MM-DD') then 'id_producto_ND49'
            --ND 50 fechaIniAnu >= '03-06-2012'
            else 'id_producto_ND50'
          END  
        
      END as id_producto_param
        
        from ca_det_liq_canon tab0 
        join ca_recibo tab1 on tab0.id_det_liq_canon=tab1.id_det_liq_canon and tab0.vigencia=tab1.vig_liq
        join ca_anual_etapa tab2 on tab0.id_anual_etapa=tab2.id_anual_etapa
        join ca_etapa tab3 on tab0.id_etapa=tab3.id_etapa
        join rmn_titulo tab4 on tab0.id_titulo=tab4.id_titulo
        left join CA_TITULO_MARCA_GOB mg on tab0.id_titulo=mg.id_titulo
        left join ca_anual_etapa_deb_v aed on tab2.ID_ANUAL_ETAPA=aed.id_anual_etapa
        where tab0.id_liq_canon=$id_liq_canon  and tab0.vigencia=$vigencia  and tab0.anulado=0 and tab0.aprobado=1)table1
        
left join 
(select 
    
titper.ID_PERSONA,
titper.NOMBRE,
titper.PRIMER_APELLIDO,
titper.SEGUNDO_APELLIDO,
titper.TELEFONO,
titper.CELULAR,
titper.CORREO,
titper.CORREO_ALT,
titper.RAZ_SOC,
titper.NUM_DOC,
titper.id_titulo,
titper.id_titulo_persona,
titper.id_titular


from rmn_titulo_persona_mv titper

join (
  SELECT 
   titper.*,
   ROW_NUMBER() OVER (
    PARTITION BY titper.id_titulo
    ORDER BY titper.id_titulo_persona ASC
   ) AS rn
  from rmn_titulo_persona_mv titper
  --mod by harold 22/06/2015 unico rol valido es titular id_rol=26 HARD CODED
  where titper.actual = 1 and titper.id_rol_titulo=26
)tab
on titper.id_titulo_persona = tab.id_titulo_persona
and titper.id_titular = tab.id_titular
and tab.rn = 1
order by
titper.id_titulo_persona )table2

on table1.id_titulo=table2.id_titulo   

where         
table2.id_titulo is null 
EOD;

                //ejecuta y obtiene el resultado del sql
                $records_cod = CN_TABLE::executeSQL($sql, true);
                $records_cod_text = "";
                //Coloca los titulos de los cuales no encuentra titular con rol de titular - 20170417
                if (count($records_cod) > 0) {
                    $records_cod_text = $records_cod[0]["cod_titulo"];
                }

                throw new Exception("Ocurrio un error, es posible que algun titular no este parametrizado o no lo este con el rol de titular, verificar Titulos($records_cod_text). "
                . "Por favor comunicarse con el administrador del sistema.");
            }


            if ($cant != 0) {

//                 $num_recibo = $records[0]['num_recibo'];

                $sql = <<<EOD
select * from ca_con_recibo where vigencia = $vigencia 
EOD;
                //ejecuta y obtiene el resultado del sql
                $records_num = CN_TABLE::executeSQL($sql, true);

                /*
                 * Actualizar con_recibo
                 */
                if (count($records_num) == 0) {
                    //Insertar el concecutivo de los recibos
                    //Insert into CA_CON_RECIBO (VIGENCIA,NUM_RECIBO_ACTUAL) values (2012,484);
                    $sql = <<<EOD
Insert into CA_CON_RECIBO (VIGENCIA,NUM_RECIBO_ACTUAL) values ( $vigencia, $cant )
EOD;
                } else {

                    //Actualiza el nuevo concecutivo de los recibos
                    $sql = <<<EOD
UPDATE ca_con_recibo SET num_recibo_actual = (select max(num_recibo) as max from ca_recibo where vig_liq = $vigencia) 
where vigencia = $vigencia
EOD;
                }

                //CN_TABLE::executeSQL($sql);
                $this->conn->execute($sql);


                $sql = <<<EOD
select * from ca_table_vig_seq where id_vigencia = $vigencia AND nom_entidad = 'CA_RECIBO'
EOD;
                //ejecuta y obtiene el resultado del sql
                $records_rec = CN_TABLE::executeSQL($sql, true);


//               $id_recibo = $records[0]['id_recibo'];

                /*
                 * Actualizar tabla_vig
                 */
                if (count($records_rec) == 0) {
                    //Insertar el nuevo tabla_vig
                    //Insert into CA_TABLE_VIG_SEQ (ID_VIGENCIA,NOM_ENTIDAD,SEQ) values (2000,'CA_LIQ_CANON',2);
                    $sql = <<<EOD
Insert into CA_TABLE_VIG_SEQ (ID_VIGENCIA,NOM_ENTIDAD,SEQ) values ( $vigencia, 'CA_RECIBO', $cant ) 
EOD;
                } else {
                    //Actualiza el tabla_vig
                    //Se cambia filtro a vigencia y no vig_liq - 20161129
                    $sql = <<<EOD
UPDATE ca_table_vig_seq SET seq = (select max(id_recibo) as max from ca_recibo where vigencia = $vigencia) 
where id_vigencia = $vigencia AND nom_entidad = 'CA_RECIBO'
EOD;
                }
                //CN_TABLE::executeSQL($sql);
                $this->conn->execute($sql);
            }

            //COMMIT DE TODAS LAS TRANSACCIONES
            $this->conn->commit();



            //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
            $id_ope_bd = 3;
            //obtener id maestro tabla
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_recibo');
            //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
            $liq = $request['id_liq_canon'];
            $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, "Se cerro la liquidación para la planilla número $liq y se crearon los recibos");



            $this->totalRows = count($records);
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($records);
            $this->status = 0;
            $this->list_data = $records;
            $this->logMessage("[LIQUIDACION_CIERRE] Generación exitosa.");
        } catch (Exception $e) {

            //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            $sql = <<<EOD
update ca_liq_canon
SET estado            =1
WHERE ID_LIQ_CANON    = $id_liq_canon
and VIGENCIA = $vigencia
EOD;

            $this->conn->execute($sql);
            $this->conn->commit();

            $this->status = 1;
            $this->mensajeError = "ERROR!!! " . $e->getMessage();
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage("Error: " . $e->getMessage());
        }
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;


        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
